{$A+,B-,D+,E+,F+,I+,L-,N-,O+,R+,S+,V+}
{$M 16384,0,655360}

program QuikLoad;

uses Dos, Crt, MPrinter, Marek, Inp;

const Hodnota : Array[1..8] of Byte = (128, 64, 32, 16, 8, 4, 2, 1);
      TypySuborov : Array[1..3] of String = ('Draft mode',
					     'Letter Quality',
					     'Proportional mode');

type Siet = array[1..29, 1..24] of Boolean;

var  I, J, K: Integer;
     Mriezka: Siet;
  MenoSuboru: String;
   TypSuboru: Byte;
      Stlpec: Byte;
    DWLsubor: File of Siet;

procedure Skonci(Sprava: String);
begin
 Sound(1200);
 Delay(600);
 NoSound;
 Writeln(' FATAL: ' + Sprava);
 Writeln;
 Halt(255);
end;

function UpStr(S: String): String;
var St: String; I: Byte;
begin
 St := '';
 for I := 1 to Length(S) do St := St + UpCase(S[I]);
 UpStr := St;
end;

begin
 Writeln;
 Writeln;
 Writeln('QUIKLOAD  for  EPSON LQ printers');
 Writeln('--------------------------------');
 Writeln;
 InitZvuk;
 if not ON then Skonci(' printer OFF');
 if ParamCount = 0 then Skonci('font name missing');
 if not Exist(ParamStr(1)) then
  Skonci('file ''' + ParamStr(1) + ''' not found');
 {---}
 MenoSuboru := UpStr(ParamStr(1));
  case MenoSuboru[Length(MenoSuboru)] of
   'D': TypSuboru := 1;
   'L': TypSuboru := 2;
   'P': TypSuboru := 3;
   else Skonci('bad file - ''' + MenoSuboru + '''');
  end;
 if TypSuboru = 2 then LQ;
 Writeln('    Font name : ' + MenoSuboru);
 Writeln('    Font type : ' + TypySuborov[TypSuboru]);
 Writeln;
 Writeln('--------------------------------');
 Writeln;
 Write(' Sending ', MenoSuboru, ' to printer...');
 ROMtoRAM;
 case MenoSuboru[Length(MenoSuboru) - 1] of
  'W': begin
	Assign(DWLSubor, MenoSuboru);
	Reset(DWLSubor);
	 for K := 1 to 94 do
	  begin
	   if K mod 2 = 0 then
	    begin
	     GotoXY( 40, WhereY);
	     Write(1.068 * K :2:0 ,'%' );
	    end;
	   Read(DWLSubor, Mriezka);
	   if (KeyPressed) AND (Readkey = #27) then Skonci('terminated');
	   E('&' + #0 + Chr(K + 32) + Chr(K + 32) + #1 + #29 + #1);
	   for I := 1 to 29 do
	    begin
	     Stlpec := 0;
	     for J := 1 to 8 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J]);
	     P(Chr(Stlpec));
	     {---}
	     Stlpec := 0;
	     for J := 9 to 16 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 8]);
	     P(Chr(Stlpec));
	     {---}
	     Stlpec := 0;
	     for J := 17 to 24 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 16]);
	     P(Chr(Stlpec));
	    end;
	  end;
	 Close(DWLSubor);
       end;
    else Skonci('bad file');
  end;
 RAM;
 Writeln;
 Writeln;
 Writeln;
 Zvuk;
 Writeln(MenoSuboru + ' is loaded in printer.');
 Writeln;
end.


