{$A+,B-,D+,E+,F+,I+,L-,N-,O+,R+,S+,V+}
{$M 16384,0,655360}

program Small;

uses Dos, Crt, MPrinter, Marek, Inp;

const Hodnota : Array[1..8] of Byte = (128, 64, 32, 16, 8, 4, 2, 1);

type Siet = array[1..10, 1..24] of Boolean;

var  I, J, K: Integer;
     Mriezka: Siet;
  MenoSuboru: String;
      Stlpec: Byte;
       Subor: File of Siet;

procedure Skonci(Sprava: String);
begin
 Sound(1200);
 Delay(600);
 NoSound;
 Writeln(' FATAL: ' + Sprava);
 Writeln;
 Halt(255);
end;

begin
 Writeln;
 Writeln;
 Writeln('SMALL font for EPSON LQ printers');
 Writeln('--------------------------------');
 Writeln;
 InitZvuk;
 if not ON then Skonci(' printer OFF');
 if not Exist('SMALL.FNT') then
  Skonci('file  SMALL.FNT not found');
 {---}
 MenoSuboru := 'SMALL.FNT';
 Write(' Sending ', MenoSuboru, ' to printer...');
 IniTialize;
 LQ;
 ROMtoRAM;
 E('3' + #8);
 Assign(Subor, MenoSuboru);
 Reset(Subor);
 for K := 1 to 94 do
  begin
   if K mod 2 = 0 then
    begin
     GotoXY( 40, WhereY);
     Write(1.068 * K :2:0 ,'%' );
    end;
   Read(Subor, Mriezka);
   if (KeyPressed) AND (Readkey = #27) then Skonci('terminated');
   E('&' + #0 + Chr(K + 32) + Chr(K + 32) + #0 + #10 + #0);
      for I := 1 to 10 do
       begin
       Stlpec := 0;
       for J := 1 to 8 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J]);
       P(Chr(Stlpec));
       {---}
       Stlpec := 0;
       for J := 9 to 16 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 8]);
       P(Chr(Stlpec));
       {---}
       Stlpec := 0;
       for J := 17 to 24 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 16]);
       P(Chr(Stlpec));
      end;
  end;
 Close(Subor);
 RAM;
 Writeln;
 Writeln;
 Writeln;
 Zvuk;
 Writeln(MenoSuboru + ' is loaded in printer.');
 Writeln;
end.


