{$A+,B-,D+,E+,F+,I+,L-,N-,O+,R+,S+,V+}
{$M 16384,0,655360}

program Dwl2bin;

uses Dos, Crt, MPrinter, Marek, Inp;

const Hodnota : Array[1..8] of Byte = (128, 64, 32, 16, 8, 4, 2, 1);

type Siet = array[1..29, 1..24] of Boolean;

var  I, J, K, L: Integer;
        Mriezka: Siet;
     MenoSuboru: String;
    MenoDSuboru: String;
         Stlpec: Byte;
       DWLsubor: File of Siet;
       BINsubor: File of Char;

procedure Skonci(Sprava: String);
begin
 Writeln;
 Sound(1200);
 Delay(600);
 NoSound;
 Writeln(' FATAL: ' + Sprava);
 Writeln;
 Halt(255);
end;

function UpStr(S: String): String;
var St: String; I: Byte;
begin
 St := '';
 for I := 1 to Length(S) do St := St + UpCase(S[I]);
 UpStr := St;
end;

procedure Fi(St: String);
begin
 for L := 1 to Length(St) do Write(BINsubor, St[L]);
end;

begin
 Writeln;
 Writeln;
 Writeln('Dwl2bin converts *.DWL to *.BIN');
 Writeln('--------------------------------');
 Writeln;
 InitZvuk;
 if ParamCount = 0 then Skonci('DWL file name missing');
 if not Exist(ParamStr(1)) then
  Skonci('DWL file ''' + ParamStr(1) + ''' not found');
 MenoSuboru := UpStr(ParamStr(1));
 if UpStr(Copy(MenoSuboru, Length(MenoSuboru) - 3, 4)) <> '.DWL'
  then Skonci(' bad file');
 {---}
 MenoDSuboru := MenoSuboru;
 Delete(MenoDSuboru, Length(MenoDSuboru) - 3, 4);
 MenoDSuboru := MenoDsuboru + '.BIN';
 Writeln;
 Write(' Converting ', MenoSuboru, ' to ', MenoDSuboru, '...');
 Assign(DWLsubor, MenoSuboru);
 Assign(BINsubor, MenoDSuboru);
 Reset(DWLsubor);
 Rewrite(BINsubor);
 {------}
 Fi(#7);
 Fi(#27 + '@');
 Fi(#27 + ':' + #0 + #0 + #0);
 Fi(#7);
 for K := 1 to 94 do
  begin
   if K mod 2 = 0 then
    begin
     GotoXY( 48, WhereY);
     Write(1.068 * K :2:0 ,'%' );
    end;
   Read(DWLsubor, Mriezka);
   if (KeyPressed) AND (Readkey = #27) then Skonci('terminated');
   Fi(#27 + '&' + #0 + Chr(K + 32) + Chr(K + 32) + #1 + #29 + #1);
   for I := 1 to 29 do
    begin
     Stlpec := 0;
     for J := 1 to 8 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J]);
     Fi(Chr(Stlpec));
     {---}
     Stlpec := 0;
     for J := 9 to 16 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 8]);
     Fi(Chr(Stlpec));
     {---}
     Stlpec := 0;
     for J := 17 to 24 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 16]);
     Fi(Chr(Stlpec));
    end;
  end;
 Fi(#27 + '%' + #1);
 Fi(#7);
 Fi(#7);
 Close(DWLsubor);
 Close(BINsubor);
 Writeln;
 Writeln;
 Writeln;
 Zvuk;
 Writeln(MenoSuboru + ' was converted to ' + MenoDSuboru);
 Writeln;
end.


