{$A+,B-,D+,E+,F+,I+,L-,N-,O+,R+,S+,V+}
{$M 16384,0,655360}

program SmallDwn;

uses Dos, Crt, Printer, MPrinter, Marek, Inp, SCR;

const   Hodnota : Array[1..8] of Byte = (128, 64, 32, 16, 8, 4, 2, 1);
      Znamienko : Array[0..1] of Char = (#32, #251);
     HodnotaOpt : Array[1..6] of Byte = (128, 64, 32, 16, 4, 1);
    TypySuborov : Array[1..3] of String = ('Draft mode', 'Letter Quality',
					    'Proportional mode');
      VelkostMriezky = 24 * 10;
       XOpt = 29;
      Tsave = 10;
      Tload = 11;
      Tprint = 12;
      Tdownload = 13;
      Toptions = 14;
      Texit = 15;

type  ZnakPtr = ^ZnakRec;
      ZnakRec = array[1..10, 1..24] of Boolean;
     ZnakList = array[1..94] of ZnakPtr;
	 Siet = array[1..10, 1..24] of Boolean;
     _Options = record
		 Nazov: String;
		 Hodnota: Boolean;
		end;


var        I, J, K, L: Integer;
		 Znak: ZnakList;
	      Mriezka: Siet;
	    ClipBoard: Siet;
	   PomMriezka: Siet;
		   Ch: Char;
	S, MenoSuboru: String;
		  EXT: String;
   DosY,X,Y,OldX,OldY: Byte;
		 STOP: Boolean;
	       Stlpec: Integer;
	Draw, Mazanie: Boolean;
	Znak3,Riadok3: Integer;
	      Pismeno: Char;
 Cpismena,OldCpismena: Byte;
	    TypSuboru: Byte;
	       Search: SearchRec;
		MenoF: Array[1..18] of String;
	       Riadok: Array[1..18] of String;
	       PocetF: Byte;
		  Opt: Array[1..7] of _Options;
	      KurzOpt: Byte;
		Subor: File of Siet;

procedure Zaciatok;
begin
 CheckBreak := FALSE;
 SaveSCR3;
 DosY := WhereY;
 ZiadnyCursor;
 InitZvuk;
 for I := 1 to 10 do for J := 1 to 24 do Mriezka[I, J] := FALSE;
 for I := 1 to 10 do for J := 1 to 24 do ClipBoard[I, J] := FALSE;
 for I := 1 to 94 do GetMem(Znak[I], VelkostMriezky);
 for I := 1 to 94 do Move(Mriezka, Znak[I]^, VelkostMriezky);
 for I := 1 to 7 do with Opt[I] do Hodnota := FALSE;
 Opt[1].Nazov := '   Underline   ';
 Opt[2].Nazov := '    Italic     ';
 Opt[3].Nazov := '   2 x Width   ';
 Opt[4].Nazov := '  2 x Strike   ';
 Opt[5].Nazov := '   Condensed   ';
 Opt[6].Nazov := '     Elite     ';
 Opt[7].Nazov := '   ---  OK  ---   ';
 KurzOpt := 1;
 STOP := FALSE;
 Draw := FALSE;
 Mazanie := FALSE;
 Pismeno := 'A';
 Cpismena := 33;
 OldCpismena := 33;
 MenoSuboru := 'NONAME';
 TypSuboru := 2;
 X := 2; OldX := X;
 Y := 12; OldY := Y;
 Znak3 := 33; Riadok3 := 1;
end;

procedure ZamenBOO(var BOO: Boolean);
begin
 BOO := not BOO;
end;

procedure F(var BOO: Boolean);
begin
 BOO := FALSE;
end;

procedure Stlac(Cislo: Byte);
begin
 TLC_PSH(Cislo);
 Delay(160);
 TLC_PRT(Cislo);
end;

procedure C(C: Byte);
begin
 TextColor(C);
end;

procedure CistaPloska;
begin
 TXTfarby(8, 15);  S:= '';  Ch := #176;
 for I := 1 to 10 do S := S + Ch;
 for I := 1 to 24 do WriteXY(1, I, S);
end;

procedure NapisMeno;
begin
 TXTfarby(10, 7);  WriteXY(63, 6, '                 ');
 WriteXY(63, 6, TypySuborov[TypSuboru]);
 TXTfarby(14, 7);  WriteXY(66, 7, '        ');
 WriteXY(66, 7, MenoSuboru);
end;

procedure ReDraw;
begin
 {$S-,R-}
 Zvuk2;
 CistaPloska;
 TXTfarby(8, 0);
 for J := 1 to 24 do for I := 1 to 10 do if Mriezka[I, J] then
  begin
   GotoXY(I, J);
   Write(Chr(177));
  end;
 GotoXY(1, 25);
 TXTfarby(14, 7);
 Write(' ' + Pismeno);
 {$S+,R+}
end;


procedure Nakresli;
begin
 Cls;
 S := ''; for I := 1 to 70 do S := S + ' ';
 Plocha(1, 7, 8, 7, S + 'DownLoad');
 CistaPloska;
 CiaraY(1, 24, 30, 7, 7, 'single');
 XWrite(30,  3, 0, 7, '_');
 XWrite(30, 20, 0, 7, '_');
 TextColor(0);
 Ramcek(1, 4, 31, 79, 8, 7, 7, 'single');
 CiaraY(1, 4, 80, 7, 7, 'none');
 for I := 33 to 79 do WriteXY(I  - 1, 2, Chr(I));
 for I := 80 to 126 do WriteXY(I - 48, 3, Chr(I));
 Ramcek(4, 25, 31, 47, 8, 7, 7, 'single');
 XWrite(31, 4, 8, 7, #195);  XWrite(47, 4, 8, 7, #194);
 Ramcek(8, 24, 48, 80, 15, 7, 7, 'double');
 Ramcek(5, 8, 48, 80, 15, 7, 7, 'double');
 TXTfarby(15, 7); WriteXY(48, 8, #204); WriteXY(80, 8, #185);
 XWrite(51, 6, 15, 7, 'Font type :');
 XWrite(51, 7, 15, 7, 'Font name :');
 TLC_INI(1, 34, 23, 3, 0, 11, 14, 7, 0, '   clea', 'R', '   ');
 TLC_INI(2, 34, 21, 3, 0, 11, 14, 7, 0, '    ', 'F', 'lip   ');
 TLC_INI(3, 34, 19, 3, 0, 11, 14, 7, 0, '    ', 'T', 'est   ');
 TLC_INI(4, 34, 17, 3, 0, 11, 14, 7, 0, ' ', 'L', 'ine feed ');
 TLC_INI(5, 34, 14, 3, 0, 15, 14, 7, 0, '   s', '', 'pace   ');
 TLC_INI(6, 34, 12, 3, 0, 15, 14, 7, 0, '   ', 'D', 'raw    ');
 TLC_INI(7, 34, 10, 3, 0, 15, 14, 7, 0, '   ', 'E', 'rase   ');
 TLC_INI(8, 34, 07, 3, 0, 11, 14, 7, 0, '   ', 'C', 'opy    ');
 TLC_INI(9, 34, 05, 3, 0, 11, 14, 7, 0, '   ', 'P', 'aste   ');
 TLC_INI(10, 50, 11, 1, 0, 11, 14, 7, 1, '   ', 'F2', ' Save   ');
 TLC_INI(11, 65, 11, 1, 0, 11, 14, 7, 1, '   ', 'F3', ' Load   ');
 TLC_INI(12, 50, 16, 1, 0, 11, 14, 7, 1, '   ', 'F5', ' Print  ');
 TLC_INI(13, 65, 16, 1, 0, 11, 14, 7, 1, ' ', 'F6', ' Download ');
 TLC_INI(14, 50, 21, 1, 0, 11, 14, 7, 1, '  ', 'F9', ' Options ');
 TLC_INI(15, 65, 21, 1, 0, 11, 14, 7, 1, '  ', 'F10', ' Exit   ');
 for I := 1 to 15 do TLC_PRT(I);
 NapisMeno;
 ReDraw;
end;

procedure Test;
begin
 Zvuk;
 TLC_PSH(3);
 if ON then
  begin
   E('&' + #0 + Pismeno + Pismeno + #1 + #10 + #1);
   for I := 1 to 10 do
    begin
     Stlpec := 0;
     for J := 1 to 8 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J]);
     P(Chr(Stlpec));
     {---}
     Stlpec := 0;
     for J := 9 to 16 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 8]);
     P(Chr(Stlpec));
     {---}
     Stlpec := 0;
     for J := 17 to 24 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 16]);
     P(Chr(Stlpec));
    end;
   RAM;
   P(' ' + Pismeno); P(' ');
  end
  else begin Zvuk2; Zvuk; Zvuk2; Zvuk; Zvuk; end;
 Zvuk;
 TLC_PRT(3);
end;

procedure Clear;
begin
 Zvuk2;
 Stlac(1);
 for I := 1 to 10 do for J := 1 to 24 do Mriezka[I, J] := FALSE;
 CistaPloska;
end;

procedure Flip;
begin
 Zvuk2;
 Stlac(2);
 PomMriezka := Mriezka;
 for I := 1 to 10 do for J := 1 to 24 do
	   Mriezka[I, J] := PomMriezka[11 - I, J];
 ReDraw;
end;

procedure LineFeed;
begin
 TLC_PSH(4);
 Pln('');
 TLC_PRT(4);
end;

procedure Copy;
begin
 Zvuk2;
 Stlac(8);
 ClipBoard := Mriezka;
end;

procedure Paste;
begin
 Zvuk2;
 Stlac(9);
 Mriezka := ClipBoard;
 ReDraw;
end;

procedure Kurzor3;
begin
 GotoXY(Znak3 + 31, Riadok3 + 1);
 TXTfarby(4, 3);
 Write(Chr(Znak3 + (Riadok3 - 1) * 15 + Riadok3 * 32));
end;

procedure Kurzor3o;
begin
 GotoXY(Znak3 + 31, Riadok3 + 1);
 TXTfarby(0, 7);
 Write(Chr(Znak3 + (Riadok3 - 1) * 15 + Riadok3 * 32));
 OldCpismena := Ord(Pismeno) - 32;
end;

procedure VymazSpace(var Stri: String);
begin
 while (Stri[1] = ' ') AND (Length(Stri) > 0) do Delete(Stri, 1, 1);
end;

procedure Cenzura(var St: String);
var Sr: String;
begin
 Sr := '';
 for I := 1 to Length(St) do if Ord(St[I]) in [48..57, 64..122] then
  Sr := Sr + St[I];
 St := Sr;
end;

procedure Save;
label KON;
begin
 Zvuk2;
 Stlac(Tsave);
 SaveSCR1;
 RamcekSTienomSprava(5, 13, 20, 60, 0, 3, 3, 'double', 14, 3, ' Save font ');
 XWrite(32, 6, 0, 3, 'Save your font as');
 case TypSuboru of
  1: EXT := 'DWD';
  2: EXT := 'DWL';
  3: EXT := 'DWP';
 end;
 XWrite(42, 8, 15, 3, '[.' + EXT + ']');
 XWrite(28, 12, 0, 3, 'Save   Cancel   New name ');
 repeat
  I := 255; K := 255;
  TXTfarby(15, 2); GotoXY(34, 8);
  S := InputTXT(8, MenoSuboru);
  VymazSpace(S);
  Cenzura(S);
  if (S = 'STOP') OR (S = '') then Goto KON;
  if Exist(S + '.' + EXT) then
   begin
    XWrite(28, 12, 0, 3, '                         ');
    XWrite(30, 10, 14, 3, 'The File allready EXIST ! ');
    Zvuk;
    XWrite(26, 12, 0, 3, '                                  ');
    GotoXY(24, 12);
    K := DialogX(15,7,0,3,1,' Overwrite ',' Cancel ', ' New name ','','','');
    XWrite(30, 10, 0, 3, '                          ');
    XWrite(25, 12, 0, 3, '                                  ');
   end
  else
   begin
    XWrite(25, 12, 0, 3, '                                  ');
    GotoXY(27, 12);
    I := DialogX(15, 7, 0, 3, 1, ' Save ', ' Cancel ', ' New name ', '','','');
   end;
 until (I <> 3) AND (K <> 3);
 if (I = 1) OR (K = 1) then
  begin;
   MenoSuboru := S;
   LoadSCR1;
   NapisMeno;
   Assign(Subor, MenoSuboru + '.' + EXT);
   Rewrite(Subor);
   Move(Mriezka, Znak[Cpismena]^,  VelkostMriezky);
   for I := 1 to 94 do
    begin
     if I mod 2 = 0 then
      begin
       GotoXY( 6, 25);
       TXTfarby(0, 7);
       Write(1.068 * I :2:0 ,'%' );
      end;
     Move(Znak[I]^, Mriezka,  VelkostMriezky);
     Write(Subor, Mriezka);
    end;
   GotoXY( 6, 25);
   Write('    ');
   Close(Subor);
   Move(Znak[Cpismena]^, Mriezka,  VelkostMriezky);
  end;
 KON:
 Zvuk2;
 LoadSCR1;
 NapisMeno;
end;

procedure Del(Ktory: Byte);
var Chr: Char; F: File;
begin
 Zvuk2;
 XWrite(5, 3, 12, 1, ' Are you sure ? ');
 Chr := UpCase(ReadKey);
 if (Chr = 'Y') OR (Chr = 'A') then
  begin
   {$I-}
   Assign(F, MenoF[Ktory]);
   Reset(F);
   Erase(F);
   Close(F);
   if DosError <> 0 then begin Zvuk; Zvuk; Zvuk; Zvuk; Zvuk; Zvuk2; Zvuk;end;
   {$I+}
  end;
end;

function Vyber: String;
var Teraz, Vtedy: Byte; Chh: Char; Deleted: Boolean;
begin
 Deleted := FALSE;
 SaveSCR1;
 RamcekSTienomSprava(2, 23, 4, 22, 7, 1, 1, 'double', 15, 1, ' Load font ');
 XWrite(5, 3, 14, 1, ' d - delete font');
 CiaraX(5, 21, 4, 7, 1, 'single');
 XWrite(4, 4, 7, 1, #199);  XWrite(22, 4, 7, 1, #182);
 if PocetF = 0 then
  begin
   XWrite(5, 5, 11, 1, ' 0 files found !');
   PoStlacenyPokracuj;
   Vyber := '!!!0files!!!';
  end
 else
  begin
   TXTfarby(11, 1);
   for I := 1 to PocetF do
    while Length(Riadok[I]) < 17 do Riadok[I] := Riadok[I] + ' ';
   for I := 1 to PocetF do WriteXY(5, I + 4, Riadok[I]);
   Teraz := 1; Vtedy := 1;
   XWrite(5, Teraz + 4, 0, 3, Riadok[Teraz]);
   repeat
    Chh := UpCase(Readkey);
    Vtedy := Teraz;
     case Chh of
      #32: Inc(Teraz);
      #68: begin Del(Teraz); Deleted := TRUE; end;
      #00: begin
	    Chh := Readkey;
	     case Klavesa(Chh) of
	      8: Dec(Teraz);
	      2: Inc(Teraz);
	      4: Dec(Teraz);
	      6: Inc(Teraz);
	      7: Teraz := 1;
	      1: Teraz := PocetF;
	      9: Teraz := 1;
	      3: Teraz := PocetF;
	    end;
	  end;
     end;
    if Teraz = 0 then Teraz := PocetF;
    if Teraz = (PocetF + 1) then Teraz := 1;
    XWrite(5, Vtedy + 4, 11, 1, Riadok[Vtedy]);
    XWrite(5, Teraz + 4, 0, 3, Riadok[Teraz]);
   until (Chh = #13) OR (Chh = #27) OR (Deleted);
   if Chh = #27 then Vyber := '!!!escape!!!';
   if Chh = #13 then Vyber := MenoF[Teraz];
   if Deleted then Vyber := '!!!delete!!!';
  end;
 LoadSCR1;
end;

procedure Load;
begin
 Zvuk2;
 Stlac(Tload);
 repeat
  PocetF := 0;
  FindFirst('*.DW?', $3F, Search);
  while (DosError = 0) AND (PocetF < 18) do
   begin
    Inc(PocetF);
    case Search.Name[Length(Search.Name)] of
     'D': S := 'draft: ';
     'L': S := '  LQ : ';
     'P': S := 'prop.: ';
    end;
    MenoF[PocetF] := Search.Name;
    Riadok[PocetF] := S + LowCase(Search.Name);
    Delete(Riadok[PocetF],Length(Riadok[PocetF]) - 3, 4);
    FindNext(Search);
   end;
  S := Vyber;
 until (S <> '!!!delete!!!') OR (PocetF = 0);
 if (S <> '!!!escape!!!') AND (PocetF > 0) then
  begin
   MenoSuboru := S;
   Delete(MenoSuboru,Length(MenoSuboru) - 3, 4);
   Assign(Subor, S);
    case S[Length(S)] of
     'D': TypSuboru := 1;
     'L': TypSuboru := 2;
     'P': TypSuboru := 3;
    end;
   Reset(Subor);
   NapisMeno;
   for I := 1 to 94 do
    begin
     if I mod 2 = 0 then
      begin
       GotoXY( 6, 25);
       TXTfarby(0, 7);
       Write(1.068 * I :2:0 ,'%' );
     end;
    Read(Subor, Mriezka);
    Move(Mriezka, Znak[I]^, VelkostMriezky);
   end;
  GotoXY( 6, 25);
  Write('    ');
  Close(Subor);
  Move(Znak[Cpismena]^, Mriezka,  VelkostMriezky);
  ReDraw;
 end;
 Zvuk2;
end;

procedure Down;
begin
 Stlac(Tdownload);
 Zvuk2;
 if ON then
  begin
   for K := 1 to 94 do
    begin
     if (KeyPressed) AND (Readkey = #27) then K := 94;
     E('&' + #0 + Chr(K + 32) + Chr(K + 32) + #0 + #10 + #0);
     GotoXY( 6, 25);
     TXTfarby(0, 7);
     Write(1.068 * K :2:0 ,'%' );
     Move(Znak[K]^, Mriezka, VelkostMriezky);
      for I := 1 to 10 do
       begin
       Stlpec := 0;
       for J := 1 to 8 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J]);
       P(Chr(Stlpec));
       {---}
       Stlpec := 0;
       for J := 9 to 16 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 8]);
       P(Chr(Stlpec));
       {---}
       Stlpec := 0;
       for J := 17 to 24 do if Mriezka[I, J] then Inc(Stlpec, Hodnota[J - 16]);
       P(Chr(Stlpec));
      end;
{     RAM; P(Chr(K + 32)); }
    end;
   RAM;
   GotoXY( 6, 25);  Write('    ');
   Move(Znak[Cpismena]^, Mriezka,  VelkostMriezky);
   Zvuk;
  end;
end;

procedure Print;
begin
 Stlac(Tprint);
 Zvuk;
 if ON then
  begin
   Pln('');
   for I := 33 to 126 do P(Chr(I) + Chr(I));
   Pln('');
  end;
 Zvuk;
end;

procedure Options;
var   ChOpt: Char;  HodOpt: Byte;
 procedure NapisOpt;
 begin
 for I := 1 to 7 do
  begin
   if I = KurzOpt then TXTfarby(0, 3) else TXTfarby(11, 1);
   if I = 7 then TXTfarby(10, 1);
   if (I = 7) AND (KurzOpt = 7) then TXTfarby(10, 3);
   GotoXY(XOpt, I + 5); Write(Opt[I].Nazov);
   if I < 7 then Write('[ ]');
   if I = KurzOpt then TXTfarby(14, 3) else TXTfarby(14, 1);
   WriteXY(XOpt + 16, I + 5, Znamienko[Ord(Opt[I].Hodnota)]);
  end;
 end;
begin
 Stlac(Toptions);
 Zvuk2;
 SaveSCR1;
 if not ON then begin Zvuk; Zvuk; Zvuk; Zvuk; Zvuk2; end
 else
  begin
   RamcekStienomSprava(5, 13, 28, 47, 15, 1, 1, 'double', 14, 1, ' Options ');
   repeat
    NapisOpt;
    ChOpt := ReadKey;
     case Klavesa(ChOpt) of
      8,4: Dec(KurzOpt);
      2,6: Inc(KurzOpt);
      7,9: KurzOpt := 1;
      1,3: KurzOpt := 7;
     end;
    if KurzOpt = 0 then KurzOpt := 7;
    if KurzOpt = 8 then KurzOpt := 1;
    if ((ChOpt = #13) OR (ChOpt = #32)) AND (KurzOpt < 7) then
    Opt[KurzOpt].Hodnota := not Opt[KurzOpt].Hodnota;
   until (ChOpt = #27) OR ((ChOpt = #13) AND (KurzOpt = 7));
   Zvuk2;
   HodOpt := 0;
   for I := 1 to 6 do if Opt[I].Hodnota then Inc(HodOpt, HodnotaOpt[I]);
   if ON then E('!' + Chr(HodOpt));
   LoadSCR1;
  end;
end;

procedure Exit;
begin
 Stlac(Texit);
 Zvuk2;
 SaveSCR1;
 RamcekStienomSprava(10, 13, 30, 50, 14,4,4,'double',15,4,' About to Quit ');
 NapisDoStreduC(11, 11, 4, 'Are you sure ?');
 GotoXY(35, 12);
 if DialogX(15, 7, 14, 4, 3, ' Yes ', ' No ', '', '', '', '') = 1 then
  begin
   TXTfarby(7, 0);
   NormCursor;
   LoadSCR3;
   GotoXY( 1, DosY);
   Writeln;
   Writeln('  DOWNLOAD for EPSON LQ printers.');
   Writeln;
   Writeln;
   Writeln('Options');
   Writeln('----------------');
   for I := 1 to 6 do
    begin
     Write(Opt[I].Nazov);
     GotoXY(WhereX - 3, WhereY);
     if Opt[I].Hodnota then Writeln(' ON') else Writeln(' OFF');
    end;
   Writeln('----------------');
   Writeln;
   Writeln(' Font Name: ' + MenoSuboru);
   Writeln;
   Zvuk2;
   Halt(0);
  end
 else LoadSCR1;
end;

procedure Klavesy;
begin
 OldX := X; OldY := Y;
 Ch := UpCase(ReadKey);
  case Ch of
   #09: begin Kurzor3o; Inc(Znak3,6); end; { tab }
   #52: begin Kurzor3o; Dec(Znak3); end;   { 4 }
   #54: begin Kurzor3o; Inc(Znak3); end;   { 6 }
   #56: begin Kurzor3o; Dec(Riadok3); end; { 8 }
   #50: begin Kurzor3o; Inc(Riadok3); end; { 2 }
{   #27: STOP := TRUE; }
   ' ': begin TLC_PSH(5); ZamenBOO(Mriezka[X, Y]); F(Draw); F(Mazanie);
	      TLC_PRT(6); TLC_PRT(7); TLC_PRT(5); end;
   'D': begin ZamenBOO(Draw); F(Mazanie); TLC_PRT(7);
	      if Draw then TLC_PSH(6) else TLC_PRT(6); end;
   'E': begin ZamenBOO(Mazanie); F(Draw); TLC_PRT(6);
	      if Mazanie then TLC_PSH(7) else TLC_PRT(7); end;
   'T': Test;
   'R': cleaR;
   'F': Flip;
   'L': LineFeed;
   'C': Copy;
   'P': Paste;
   #00: begin
	 Ch := UpCase(ReadKey);
	  case Ch of
	   #15: begin Kurzor3o; Dec(Znak3,6); end; { S - tab }
	   #60: Save;  { F2 }
	   #61: Load;  { F3 }
	   #63: Print; { F5 }
	   #64: Down;  { F6 }
	   #67: Options; { F9 }
	   #68: Exit;  { F10 }
	  end;
	  case Klavesa(Ch) of
	   8: Dec(Y);
	   2: Inc(Y);
	   4: Dec(X);
	   6: Inc(X);
	   7: begin Dec(X); Dec(Y); end;
	   9: begin Inc(X); Dec(Y); end;
	   1: begin Dec(X); Inc(Y); end;
	   3: begin Inc(X); Inc(Y); end;
	  end;
       end;
  end;
 if X = 0 then X := 10;  if X = 11 then X := 1;
 if Y = 0 then Y := 24;  if Y = 25 then Y := 1;
 if Draw then Mriezka[X, Y] := TRUE;
 if Mazanie then Mriezka[X, Y] := FALSE;
 if (Ord(Ch) in [50..56]) OR (Ord(Ch) = 9) OR (Ord(Ch) = 15) then
  begin
   if Riadok3 = 0 then Riadok3 := 2;
   if Riadok3 = 3 then Riadok3 := 1;
   if (Znak3<=0) AND (Riadok3 = 1) then begin Znak3 := 47; Riadok3 := 2; end;
   if (Znak3<=0) AND (Riadok3 = 2) then begin Znak3 := 47; Riadok3 := 1; end;
   if (Znak3>=48) AND (Riadok3 = 1) then begin Znak3 := 1; Riadok3 := 2; end;
   if (Znak3>=48) AND (Riadok3 = 2) then begin Znak3 := 1; Riadok3 := 1; end;
   if Draw then begin Draw := FALSE; TLC_PRT(6); end;
   if Mazanie then begin Mazanie := FALSE; TLC_PRT(7); end;
   Mazanie := FALSE;
   Kurzor3;
   Pismeno := Chr(Znak3 + (Riadok3 - 1) * 15 + Riadok3 * 32);
   Cpismena := Ord(Pismeno) - 32;
   Move(Mriezka, Znak[OldCpismena]^, VelkostMriezky);
   Move(Znak[Cpismena]^, Mriezka,  VelkostMriezky);
   ReDraw;
  end;
end;

procedure Kurzor;
begin
 GotoXY(OldX, OldY);
 if Mriezka[OldX, OldY] = FALSE then
  begin
   TXTfarby(8, 15); Write(Chr(176));
  end
 else
  begin
   TXTfarby(8, 0); Write(Chr(177));
  end;
 {---}
 if Mriezka[X, Y] = FALSE then TXTfarby(1, 7)
  else TXTfarby(9, 1);
 GotoXY(X, Y);
 Write(Chr(177));
 GotoXY(15, 25);
 TXTfarby(8, 7);
 Write(X:2, '/', Y:2);
end;

procedure Tlaciaren;
begin
 if  ON = FALSE then
  begin
   XWrite(48, 25, 4, 7, 'Turn ON the printer !');
   Zvuk; Delay(300); Zvuk; Delay(200); Zvuk; Delay(100); Zvuk; Zvuk2;
   repeat until ON;
  end;
 XWrite(48, 25, 4, 7, '                     ');
 Initialize;
 LQ;
 ROMtoRAM;
end;


begin
 Zaciatok;
 Nakresli;
 Tlaciaren;
 Kurzor3;
 repeat
  Kurzor;
  Klavesy;
 until STOP;
end.


